Bug 4748 - RAID autodetect fails - initrd problem?
RAID autodetect fails - initrd problem?
Status: CLOSED NEXTRELEASE
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
6.0
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: David Lawrence
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 1999-08-27 11:01 EDT by Simon Hill
Modified: 2008-05-01 11:37 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 1999-08-31 16:00:36 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Simon Hill 1999-08-27 11:01:20 EDT
System: Supermicro P6DGS w/onboard Adaptec 7895, 2
PII-400MHz processors, 256Mb ECC SDRAM, 1 8.4Gb WD IDE, 2
4.5Gb Seagate Barracudas (SCSI).

Install: Almost "everything" install onto IDE drive went
fine. Identical partitioning of SCSI drive successful.
Created /etc/raidtab with md0 through md6, mkraid
successful.  Shut down RAID, changed partition types to
'fd'. (All this from
/usr/doc/raidtools-0.90/Software-RAID.HOWTO.txt).

Kernel: Stock RH6.0 vmlinuz-2.2.5-15smp
Initrd: Stock RH6.0 initrd-2.2.5-15smp.img

Reboot: Adaptec-7895 is found and configured.  Both SCSI
drives are found and partitioning is correctly reported.
Then (using md0 as example, this happens for all mdX):

kernel: autodetecting RAID arrays
kernel: (read) sda12's sb offset: 256896 [events: 00000002]
kernel: (read) sdb12's sb offset: 256896 [events: 00000002]
kernel: autorun ...
kernel: considering sdb12 ...
kernel:   adding sdb12 ...
kernel:   adding sda12 ...
kernel: created md0
kernel: bind<sda12,1>
kernel: bind<sdb12,2>
kernel: running: <sdb12><sda12>
kernel: now!
kernel: sdb12's event counter: 00000002
kernel: sda12's event counter: 00000002
kernel: kmod: failed to exec /sbin/modprobe -s -k
md-personality-3, errno = 2
kernel: do_md_run() returned -22
kernel: unbind<sdb12,1>
kernel: export_rdev(sdb12)
kernel: unbind<sda12,0>
kernel: export_rdev(sda12)
kernel: md0 stopped.

The problem would appear to be that md-personality-3 is not
available at boot from RAM disk.  I have not been able to
verify this, as all my attempts to mount the initrd file via
the loopback device have failed with "wrong fs, bad option,
bad superblock on /dev/loop0..." -- so I guess I don't have
the necessary knowledge to do this, and I can't find any
info on it.

Anyway, it appears to me that some modules to support
software RAID may need to be added to initrd.  This will
prove necessary for anyone wanting to have a RAID /
partition.
Comment 1 Bill Nottingham 1999-08-27 12:15:59 EDT
This should be fixed in the latest mkinitrd;
in the meantime running:
mkinitrd --with=<raid personality modules>

should work...

------- Additional Comments From   08/31/99 00:24 -------
Yes. That got the autodetect working.  Thank you.

I still have not been able to get a RAID / partition working, however.
Here's what I did:

mount /dev/md0 /mnt/raid
tar --one-file-system -cf - / | tar -C /mnt/raid -xvf -

changed /mnt/raid/etc/lilo.conf -> root=/dev/md0
changed /mnt/raid/etc/fstab     -> /dev/md0  /

mounted my /boot partition under /mnt/raid/boot

lilo -r /mnt/raid -C /etc/lilo.conf

This appears to have worked correctly, as upon reboot /dev/md0 is
correctly audodetected and started, I get:

fsck: /dev/md0: clean ...
rc.sysinit: Checking root filesystem succeeded
rc.sysinit: Remounting root file-system in read-write mode succeeded

other file systems (not yet raid) successfully mounted

then:

atd[xxx]: Error redirecting I/O: Permission denied
atd: atd startup failed

Then, if in runlevel 5:

X starts to come up, flashes, fails, and then repeats this
indefinitely.  I can't switch virtual terminals, but I can telnet in.
df shows that /dev/md0 is mounted as root, attempting to run atd logs
the same error. Upon shutting down, I get:

xfs: shutdown failed
atd: shutdown failed

The permission denied for atd is perplexing.  I poked around a little,
and tried changing permissions on /dev/md0 to match other partition
devices (ie group -> disk, and 640) with the same result.  I'm
guessing that if I can solve the atd permission denied problem, that
the X problem will go away also.

Did I screw up the copy? Everything appears to be correct, w/correct
permissions, etc. Device files must be OK, or I wouldn't have gotten
this far...

Any ideas?
Comment 2 Anonymous 1999-08-31 00:41:59 EDT
BTW, I'd better mention that I upgraded to the 2.2.5-22smp kernel,
That went fine, I did all the necessary mkinitrd and lilo stuff and
all works well with a non-RAID / partition.  (Although mkbootdisk
didn't include the raid personality modules when making the boot
floppy). I also installed all other updates except Netscape and Gnome.
Comment 3 Bill Nottingham 1999-08-31 16:00:59 EDT
mkinitrd has been fixed in Raw Hide to automatically add
raid modules.

Note You need to log in before you can comment on or make changes to this bug.